function J = Pjump_gen(B,deg,mu)
% Equivalent computation of J = \int_0^{\infty} V(x+h)dF(h) - V(x);
% Only for jump in one state variable (in this case state x1)
%\\\\\\\\\\\\ Input \\\\\\\\\%
% B     = parameterized Barrier function
% deg   = order of barrier function
% mu    = (poisson) jump size parameter

pvar x1
switch deg
    case 2
        J = diff(diff(B,x1),x1)*moments(mu,2)/factorial(2)...
            + diff(B,x1)*moments(mu,1);
    case 3
        J = diff(diff(diff(B,x1),x1),x1)*moments(mu,3)/factorial(3)...
            + diff(diff(B,x1),x1)*moments(mu,2)/factorial(2)...
            + diff(B,x1)*moments(mu,1);
    case 4
        J = diff(diff(diff(diff(B,x1),x1),x1),x1)*moments(mu,4)/factorial(4)...
            + diff(diff(diff(B,x1),x1),x1)*moments(mu,3)/factorial(3)...
            + diff(diff(B,x1),x1)*moments(mu,2)/factorial(2)...
            + diff(B,x1)*moments(mu,1);
    case 5
        J = diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1)*moments(mu,5)/factorial(5)...
            + diff(diff(diff(diff(B,x1),x1),x1),x1)*moments(mu,4)/factorial(4)...
            + diff(diff(diff(B,x1),x1),x1)*moments(mu,3)/factorial(3)...
            + diff(diff(B,x1),x1)*moments(mu,2)/factorial(2)...
            + diff(B,x1)*moments(mu,1);
    case 6
        J = diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1)*moments(mu,6)/factorial(6)...
            + diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1)*moments(mu,5)/factorial(5)...
            + diff(diff(diff(diff(B,x1),x1),x1),x1)*moments(mu,4)/factorial(4)...
            + diff(diff(diff(B,x1),x1),x1)*moments(mu,3)/factorial(3)...
            + diff(diff(B,x1),x1)*moments(mu,2)/factorial(2)...
            + diff(B,x1)*moments(mu,1);
    case 7
        J = diff(diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1),x1)*moments(mu,7)/factorial(7)...
            + diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1)*moments(mu,6)/factorial(6)...
            + diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1)*moments(mu,5)/factorial(5)...
            + diff(diff(diff(diff(B,x1),x1),x1),x1)*moments(mu,4)/factorial(4)...
            + diff(diff(diff(B,x1),x1),x1)*moments(mu,3)/factorial(3)...
            + diff(diff(B,x1),x1)*moments(mu,2)/factorial(2)...
            + diff(B,x1)*moments(mu,1);
    case 8
        J = diff(diff(diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1),x1),x1)*moments(mu,8)/factorial(8)...
            + diff(diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1),x1)*moments(mu,7)/factorial(7)...
            + diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1)*moments(mu,6)/factorial(6)...
            + diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1)*moments(mu,5)/factorial(5)...
            + diff(diff(diff(diff(B,x1),x1),x1),x1)*moments(mu,4)/factorial(4)...
            + diff(diff(diff(B,x1),x1),x1)*moments(mu,3)/factorial(3)...
            + diff(diff(B,x1),x1)*moments(mu,2)/factorial(2)...
            + diff(B,x1)*moments(mu,1);
    case 10
        J = diff(diff(diff(diff(diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1),x1),x1),x1),x1)*moments(mu,10)/factorial(10)...
            + diff(diff(diff(diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1),x1),x1),x1)*moments(mu,9)/factorial(9)...
            + diff(diff(diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1),x1),x1)*moments(mu,8)/factorial(8)...
            + diff(diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1),x1)*moments(mu,7)/factorial(7)...
            + diff(diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1),x1)*moments(mu,6)/factorial(6)...
            + diff(diff(diff(diff(diff(B,x1),x1),x1),x1),x1)*moments(mu,5)/factorial(5)...
            + diff(diff(diff(diff(B,x1),x1),x1),x1)*moments(mu,4)/factorial(4)...
            + diff(diff(diff(B,x1),x1),x1)*moments(mu,3)/factorial(3)...
            + diff(diff(B,x1),x1)*moments(mu,2)/factorial(2)...
            + diff(B,x1)*moments(mu,1);
end