%drury
alf = 0.7;
del = 0.075;
kap = 0.1;
r   = 1.5;
bet = 0.9;
eps = 0.01;
eta = 1;

prey_isocline = [];

for x=0:.01:1;
    y = (x-x.^2)*(kap^2+x^2)/(alf*kap*kap*x+alf*x^3+del*x^2);
    prey_isocline = [prey_isocline ; x y];
end;

pred_isocline = [];
for x=0:.01:1;
    y=1-bet*x-(eps/r)*(del*x*x)/(kap^2+x^2);
    pred_isocline = [pred_isocline ; x y];
end;

separatrix = [0 0];

xmax=.3;
dx = .01;
y  = .0078;
for x=dx:dx:xmax;
    num = (r*y-bet*r*x*y-r*y*y)*(kap^2+x^2)+eps*del*y*x^2;
    den = (x-x^2-alf*x*y)*(kap^2+x^2)-del*y*x^2;
    dydx = num/den;
    y   = y + dydx*dx;
    separatrix = [separatrix; x y];
end;

% traj = [];
% tstop = 10;
% dt = .001;
% x = .75; y = .35;
% 
% for time=0:dt:tstop;
%     F = x*(1-x-alf*y)-(del*y*x*x)/(kap*kap+x*x);
%     G = r*y*(1-bet*x-y)+eps*(del*y*x*x)/(kap*kap+x*x);
%     
%     if (rand(1,1)<= .0001);
%         x=x-.2;
%     end;
%     
%     x = max(0,x + F*dt);
%     y = max(0,y + G*dt);
%     traj=[traj; x y];
% end;

    
    

figure(1);
plot( prey_isocline(:,1),prey_isocline(:,2), pred_isocline(:,1), pred_isocline(:,2),separatrix(:,1),separatrix(:,2),'--');
axis([0 1 0 1]); grid on;    

tstop = 100;
dt = .01;


lamdat = logspace(-4,-2,25);

ntrial = 100;

data = [];

%for lam = .0001:.0001:.0015;
for l = 1:1:length(lamdat);
    lam = lamdat(l);
    
    MPTD = [];

for k=1:ntrial;
    traj=[];
    x = .7; y = .35;

    nsd = rand(1,1);
    tau = -log(nsd)*dt/lam;

    passage_time = -1;
    
    
    for time=0:dt:tstop;
        F = x*(1-x-alf*y)-(del*y*x*x)/(kap*kap+x*x);
        G = r*y*(1-bet*x-y)+eps*(del*y*x*x)/(kap*kap+x*x);
    
        if (time <= tau+dt)&(time >= tau)
            x=x-.2;
            nsd = rand(1,1);
            deltau = -log(nsd)/lam;
            tau = time+deltau*dt;
        end;
    
        x = max(0,x + F*dt);
        y = max(0,y + G*dt);
    
    
        traj=[traj; x y];
        
        for i=1:1:length(separatrix) 
            if (x <= separatrix(i,1))&(y >= separatrix(i,2));
               passage_time = time
               break;
            end;
        end;

         if (passage_time >= 0);
             break; 
         end;
    end;
    
    if (passage_time >=0 );
        MPTD = [MPTD ; passage_time];
    end

    
    

%     pause(1);
%     figure(2);
%     plot( prey_isocline(:,1),prey_isocline(:,2), pred_isocline(:,1), pred_isocline(:,2),separatrix(:,1),separatrix(:,2),'--',traj(:,1),traj(:,2));
%     axis([0 1 0 1]); grid on;  
end

MPT=mean(MPTD);
[lam MPT   length(MPTD)/ntrial];

data = [data ; lam MPT length(MPTD)/ntrial]

end;



