tstop = 100;
dt   = .005;
In = 2;
rn = 1.0;
gam = 2.36;
k1 = .1;
r1 = .5;
k2 = .1;
d1 = 0.15;
d2 = 1.;
eta = 0.05;
f = 1;
g1 = 0.0;
dD = 1;

data = [];
N = .1; Np = N;
D = 1;     Dp = D;
X = 10; Xp = X;
Y = 1;  Yp = Y;

 Ndotp = In - rn*Np - (gam*r1*Xp*Np/(k1+Np)) + gam*dD*Dp;
 Xdotp = r1*Xp*Np/(k1+Np) - (f*Yp*Xp/(k2+Xp)) - d1*Xp - g1*Xp*Xp;
 Ydotp = eta*f*Yp*Xp/(k2+Xp) - d2*Yp;
 Ddotp = ((1-eta)*f*Yp*Xp/(k2+Xp))+d1*Xp + d2*Yp +g1*Xp*Xp -dD*Dp;

for time=0:dt:tstop;
    Nhat = Np + dt*Ndotp;
    Xhat = Xp + dt*Xdotp;
    Yhat = Yp + dt*Ydotp;
    Dhat = Dp + dt*Ddotp;
    
    Ndot = In - rn*Nhat - (gam*r1*Xhat*Nhat/(k1+Nhat)) + gam*dD*Dhat;
    Xdot = r1*Xhat*Nhat/(k1+Nhat) - (f*Yhat*Xhat/(k2+Xhat)) - d1*Xhat - g1*Xhat*Xhat;
    Ydot = eta*f*Yhat*Xhat/(k2+Xhat) - d2*Yhat;
    Ddot = ((1-eta)*f*Yhat*Xhat/(k2+Xhat))+d1*Xhat + d2*Yhat +g1*Xhat*Xhat -dD*Dhat;
    
    N = max(0,Np+0.5*dt*(Ndot+Ndotp)); if (N <= 1.e-10); N=0;end;
    X = max(0,X+0.5*dt*(Xdot+Xdotp)); if (X <= 1.e-10); X=0; end;
    Y = max(0,Y+0.5*dt*(Ydot+Ydotp)); if (Y <= 1.e-10); Y=0; end;
    D = max(0,D+0.5*dt*(Ddot+Ddotp)); if (D <= 1.e-10); D=0; end;
   
    Xp=X;Yp=Y;Dp=D;Np=N;
    Xdotp=Xdot;Ydotp=Ydot;Ddotp=Ddot;Ndotp=Ndot;
    
    data = [data; time N X Y D];
end;
clf;
figure(1);
subplot(4,1,1);
plot(data(:,1),data(:,3));
subplot(4,1,2);
plot(data(:,1),data(:,4));
subplot(4,1,3);
plot(data(:,1),data(:,2));
subplot(4,1,4);
plot(data(:,1),data(:,5));
